      subroutine triang(deg,xupt,yupt,scale1,scale2,shift1,shift2,surf,
     1     points,cells,nxuptm)
      implicit none
c     tenta di fare una specie di triangolazione
      integer dim
      parameter (dim=3)
      integer deg,cells(dim*nxuptm,dim)
      double precision xupt(*),yupt(*)
      double precision x1,x2,x3,funct3d,scale1,scale2,
     1     shift1,shift2,rtemp,points(dim*nxuptm,dim+1)
      integer deg2,index,i,j,nxupt,nel,ncell
      external funct3d,surf
      nxupt=deg*(deg+2)/2
      ncell=0
c     bordo inferiore
      deg2=deg/2
      do i=1,deg2-1
         ncell=ncell+1
         index=i
         x1=scale1*cos(xupt(index))+shift1
         x2=scale2*cos(yupt(index))+shift2
         call surf(x1,x2,x1,x2,x3)
         points(index,1)=x1
         points(index,2)=x2
         points(index,3)=x3
         points(index,4)=funct3d(x1,x2,surf)
         cells(ncell,1)=index-1
         index=i+deg2+1
         x1=scale1*cos(xupt(index))+shift1
         x2=scale2*cos(yupt(index))+shift2
         call surf(x1,x2,x1,x2,x3)
         points(index,1)=x1
         points(index,2)=x2
         points(index,3)=x3
         points(index,4)=funct3d(x1,x2,surf)
         cells(ncell,2)=index-1
         index=i+1
         x1=scale1*cos(xupt(index))+shift1
         x2=scale2*cos(yupt(index))+shift2
         call surf(x1,x2,x1,x2,x3)
         points(index,1)=x1
         points(index,2)=x2
         points(index,3)=x3
         points(index,4)=funct3d(x1,x2,surf)
         cells(ncell,3)=index-1
      end do
c     bordo sx
      do i=deg2+1,deg2+1+(deg2-2)*(deg+1),deg+1
         ncell=ncell+1
         index=i
         x1=scale1*cos(xupt(index))+shift1
         x2=scale2*cos(yupt(index))+shift2
         call surf(x1,x2,x1,x2,x3)
         points(index,1)=x1
         points(index,2)=x2
         points(index,3)=x3
         points(index,4)=funct3d(x1,x2,surf)
         cells(ncell,1)=index-1
         index=i+deg2+1
         x1=scale1*cos(xupt(index))+shift1
         x2=scale2*cos(yupt(index))+shift2
         call surf(x1,x2,x1,x2,x3)
         points(index,1)=x1
         points(index,2)=x2
         points(index,3)=x3
         points(index,4)=funct3d(x1,x2,surf)
         cells(ncell,2)=index-1
         index=i+deg+1
         x1=scale1*cos(xupt(index))+shift1
         x2=scale2*cos(yupt(index))+shift2
         call surf(x1,x2,x1,x2,x3)
         points(index,1)=x1
         points(index,2)=x2
         points(index,3)=x3
         points(index,4)=funct3d(x1,x2,surf)
         cells(ncell,3)=index-1
      end do
c     bordo sup
      do i=1+deg2*(deg+1),deg2-1+deg2*(deg+1)
         ncell=ncell+1
         index=i
         x1=scale1*cos(xupt(index))+shift1
         x2=scale2*cos(yupt(index))+shift2
         call surf(x1,x2,x1,x2,x3)
         points(index,1)=x1
         points(index,2)=x2
         points(index,3)=x3
         points(index,4)=funct3d(x1,x2,surf)
         cells(ncell,1)=index-1
         index=i-deg2
         x1=scale1*cos(xupt(index))+shift1
         x2=scale2*cos(yupt(index))+shift2
         call surf(x1,x2,x1,x2,x3)
         points(index,1)=x1
         points(index,2)=x2
         points(index,3)=x3
         points(index,4)=funct3d(x1,x2,surf)
         cells(ncell,2)=index-1
         index=i+1
         x1=scale1*cos(xupt(index))+shift1
         x2=scale2*cos(yupt(index))+shift2
         call surf(x1,x2,x1,x2,x3)
         points(index,1)=x1
         points(index,2)=x2
         points(index,3)=x3
         points(index,4)=funct3d(x1,x2,surf)
         cells(ncell,3)=index-1
      end do
c     bordo dx
      do i=deg+1,deg+1+(deg2-2)*(deg+1),deg+1
         ncell=ncell+1
         index=i
         x1=scale1*cos(xupt(index))+shift1
         x2=scale2*cos(yupt(index))+shift2
         call surf(x1,x2,x1,x2,x3)
         points(index,1)=x1
         points(index,2)=x2
         points(index,3)=x3
         points(index,4)=funct3d(x1,x2,surf)
         cells(ncell,1)=index-1
         index=i+deg2
         x1=scale1*cos(xupt(index))+shift1
         x2=scale2*cos(yupt(index))+shift2
         call surf(x1,x2,x1,x2,x3)
         points(index,1)=x1
         points(index,2)=x2
         points(index,3)=x3
         points(index,4)=funct3d(x1,x2,surf)
         cells(ncell,2)=index-1
         index=i+deg+1
         x1=scale1*cos(xupt(index))+shift1
         x2=scale2*cos(yupt(index))+shift2
         call surf(x1,x2,x1,x2,x3)
         points(index,1)=x1
         points(index,2)=x2
         points(index,3)=x3
         points(index,4)=funct3d(x1,x2,surf)
         cells(ncell,3)=index-1
      end do
c     
      do i=1,deg2
         do j=0,(deg+1)*(deg2-1),deg+1
            ncell=ncell+1
            index=i+j
            x1=scale1*cos(xupt(index))+shift1
            x2=scale2*cos(yupt(index))+shift2
            call surf(x1,x2,x1,x2,x3)
            points(index,1)=x1
            points(index,2)=x2
            points(index,3)=x3
            points(index,4)=funct3d(x1,x2,surf)
            cells(ncell,1)=index-1
            index=i+j+deg2
            x1=scale1*cos(xupt(index))+shift1
            x2=scale2*cos(yupt(index))+shift2
            call surf(x1,x2,x1,x2,x3)
            points(index,1)=x1
            points(index,2)=x2
            points(index,3)=x3
            points(index,4)=funct3d(x1,x2,surf)
            cells(ncell,2)=index-1
            index=i+j+deg+1
            x1=scale1*cos(xupt(index))+shift1
            x2=scale2*cos(yupt(index))+shift2
            call surf(x1,x2,x1,x2,x3)
            points(index,1)=x1
            points(index,2)=x2
            points(index,3)=x3
            points(index,4)=funct3d(x1,x2,surf)
            cells(ncell,3)=index-1
            index=i+j
            x1=scale1*cos(xupt(index))+shift1
            x2=scale2*cos(yupt(index))+shift2
            call surf(x1,x2,x1,x2,x3)
            points(index,1)=x1
            points(index,2)=x2
            points(index,3)=x3
            points(index,4)=funct3d(x1,x2,surf)
            cells(ncell,1)=index-1
            index=i+j+deg+1
            x1=scale1*cos(xupt(index))+shift1
            x2=scale2*cos(yupt(index))+shift2
            call surf(x1,x2,x1,x2,x3)
            points(index,1)=x1
            points(index,2)=x2
            points(index,3)=x3
            points(index,4)=funct3d(x1,x2,surf)
            cells(ncell,2)=index-1
            index=i+j+deg2+1
            x1=scale1*cos(xupt(index))+shift1
            x2=scale2*cos(yupt(index))+shift2
            call surf(x1,x2,x1,x2,x3)
            points(index,1)=x1
            points(index,2)=x2
            points(index,3)=x3
            points(index,4)=funct3d(x1,x2,surf)
            cells(ncell,3)=index-1
         end do
      end do
c     
      do i=deg2+2,deg2+2+deg2-2
         do j=0,(deg+1)*(deg2-2),deg+1
            ncell=ncell+1

            index=i+j
            x1=scale1*cos(xupt(index))+shift1
            x2=scale2*cos(yupt(index))+shift2
            rtemp=funct3d(x1,x2,surf)
            call surf(x1,x2,x1,x2,x3)
            write(10,3) x1,x2,x3,rtemp,index
            index=i+j+deg2
            x1=scale1*cos(xupt(index))+shift1
            x2=scale2*cos(yupt(index))+shift2
            rtemp=funct3d(x1,x2,surf)
            call surf(x1,x2,x1,x2,x3)
            write(10,3) x1,x2,x3,rtemp,index
            index=i+j+deg+1
            x1=scale1*cos(xupt(index))+shift1
            x2=scale2*cos(yupt(index))+shift2
            rtemp=funct3d(x1,x2,surf)
            call surf(x1,x2,x1,x2,x3)
            write(10,3) x1,x2,x3,rtemp,index
            write(10,*)
            index=i+j
            x1=scale1*cos(xupt(index))+shift1
            x2=scale2*cos(yupt(index))+shift2
            rtemp=funct3d(x1,x2,surf)
            call surf(x1,x2,x1,x2,x3)
            write(10,3) x1,x2,x3,rtemp,index
            index=i+j+deg2+1
            x1=scale1*cos(xupt(index))+shift1
            x2=scale2*cos(yupt(index))+shift2
            rtemp=funct3d(x1,x2,surf)
            call surf(x1,x2,x1,x2,x3)
            write(10,3) x1,x2,x3,rtemp,index
            index=i+j+deg+1
            x1=scale1*cos(xupt(index))+shift1
            x2=scale2*cos(yupt(index))+shift2
            rtemp=funct3d(x1,x2,surf)
            call surf(x1,x2,x1,x2,x3)
            write(10,3) x1,x2,x3,rtemp,index
            write(10,*)
         end do
      end do         
 3    format(4(1x,e15.8),1x,i4)
      return
      end
